# EKFfixed Class Reference

Extended Kalman Filter with full matrices in fixed point arithmetic. More...

`#include <ekf_obj.h>`

Inheritance diagram for EKFfixed:

[legend]
Collaboration diagram for EKFfixed:

[legend]

List of all members.

## Public Member Functions
void | init_ekf (double Tv)
void | ekf (double ux, double uy, double isxd, double isyd)
void | prediction (int *ux)
void | correction (void)
void | update_psi (void)
| EKFfixed (RV rvx, RV rvc)
| Default constructor.
void | bayes (const vec &dt)
| Here dt = [yt;ut] of appropriate dimensions.
epdf & | _epdf ()
| dummy!
void | condition (const vec &Q0)
| Substitute `val` for `rvc`.
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual const epdf & | _epdf () const =0
| Returns a reference to the epdf representing posterior density on parameters.
virtual const epdf * | _e () const =0
| Returns a pointer to the epdf representing posterior density on parameters. Use with care!
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | predictor (const RV &rv) const
| Constructs a predictive density (marginal density on data).
const RV & | _rv () const
| access function
double | _ll () const
| access function
void | set_evalll (bool evl0)
| access function
virtual BM * | _copy_ (bool changerv=false)
const RV & | _rvc () const
| access function
## Public Attributes
int | Q [16]
int | R [4]
int | x_est [4]
int | x_pred [4]
int | P_pred [16]
int | P_est [16]
int | Y_mes [2]
int | ukalm [2]
int | Kalm [8]
int | PSI [16]
int | temp15a [16]
int | cA
int | cB
int | cC
int | cG
int | cH
long | temp30a [4]
enorm< fsqmat > | E
mat | Ry
## Protected Attributes
RV | rv
| Random variable of the posterior.
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
RV | rvc
| Identificator of the conditioning variable.

## Detailed Description

Extended Kalman Filter with full matrices in fixed point arithmetic.

An approximation of the exact Bayesian filter with Gaussian noices and non-linear evolutions of their mean.

## Member Function Documentation

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

Referenced by bdm::BM::logpred_m().

virtual BM* bdm::BM::_copy_ | ( | bool | changerv = `false` | ) | `[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype: BM* _copy_(){BM Tmp*=new Tmp(this*); return Tmp; }

Reimplemented in bdm::ARX, and bdm::BMEF.

The documentation for this class was generated from the following files:

- work/git/mixpp/pmsm/simulator_zdenek/ekf_example/ekf_obj.h
- work/git/mixpp/pmsm/simulator_zdenek/ekf_example/ekf_obj.cpp